message(STATUS "finding Bitmain Sophon SDK")
set(BMSDK_COMPONETS BASE CV DNN BMLIB RUNTIME BMVIDEO AVCODEC AVDEVICE AVFILTER AVFORMAT AVUTIL POSTPROC AVSWRESAMPLE AVSWSCALE)
# find sub dir include
find_path(BMSDK_BASE_INCLUDE_DIR
          NAMES op_code.h
          PATHS "${BMSDK_PATH}/include"
          NO_DEFAULT_PATH)
find_path(BMSDK_CV_INCLUDE_DIR
          NAMES bmcv_api.h
          PATHS "${BMSDK_PATH}/include/bmcv"
          NO_DEFAULT_PATH)
find_path(BMSDK_DNN_INCLUDE_DIR
          NAMES bmdnn_api.h bmdnn_ext_api.h
          PATHS "${BMSDK_PATH}/include/bmdnn"
          NO_DEFAULT_PATH)
find_path(BMSDK_BMLIB_INCLUDE_DIR
          NAMES bmlib_runtime.h bmlib_utils.h
          PATHS "${BMSDK_PATH}/include/bmlib"
          NO_DEFAULT_PATH)
find_path(BMSDK_RUNTIME_INCLUDE_DIR
          NAMES bm_mem_desc.h bmruntime_interface.h
          PATHS "${BMSDK_PATH}/include/bmruntime"
          NO_DEFAULT_PATH)
find_path(BMSDK_AVCODEC_INCLUDE_DIR
          NAMES libavcodec
          PATHS "${BMSDK_PATH}/lib/bmcv/ffmpeg/include"
          NO_DEFAULT_PATH)
find_path(BMSDK_AVDEVICE_INCLUDE_DIR
          NAMES libavdevice
          PATHS "${BMSDK_PATH}/lib/bmcv/ffmpeg/include"
          NO_DEFAULT_PATH)
find_path(BMSDK_AVFILTER_INCLUDE_DIR
          NAMES libavfilter
          PATHS "${BMSDK_PATH}/lib/bmcv/ffmpeg/include"
          NO_DEFAULT_PATH)
find_path(BMSDK_AVFORMAT_INCLUDE_DIR
          NAMES libavformat
          PATHS "${BMSDK_PATH}/lib/bmcv/ffmpeg/include"
          NO_DEFAULT_PATH)
find_path(BMSDK_AVUTIL_INCLUDE_DIR
          NAMES libavutil
          PATHS "${BMSDK_PATH}/lib/bmcv/ffmpeg/include"
          NO_DEFAULT_PATH)
find_path(BMSDK_POSTPROC_INCLUDE_DIR
          NAMES libpostproc
          PATHS "${BMSDK_PATH}/lib/bmcv/ffmpeg/include"
          NO_DEFAULT_PATH)
find_path(BMSDK_AVSWRESAMPLE_INCLUDE_DIR
          NAMES libswresample
          PATHS "${BMSDK_PATH}/lib/bmcv/ffmpeg/include"
          NO_DEFAULT_PATH)
find_path(BMSDK_AVSWSCALE_INCLUDE_DIR
          NAMES libswscale
          PATHS "${BMSDK_PATH}/lib/bmcv/ffmpeg/include"
          NO_DEFAULT_PATH)
# find sub dir library
find_library(BMSDK_CV_LIBRARY
             NAMES bmcv_device
             PATHS "${BMSDK_PATH}/lib/app")
find_library(BMSDK_DNN_LIBRARY
             NAMES bmdnn_device
             PATHS "${BMSDK_PATH}/lib/app")
find_library(BMSDK_BMLIB_LIBRARY
             NAMES bmlib_device
             PATHS "${BMSDK_PATH}/lib/app")
find_library(BMSDK_RUNTIME_LIBRARY
             NAMES bmrt
             PATHS "${BMSDK_PATH}/lib/app")
find_library(BMSDK_BMVIDEO_LIBRARY
             NAMES bmvideo
             PATHS "${BMSDK_PATH}/lib/bmcv/decode/lib")
find_library(BMSDK_AVFORMAT_LIBRARY
             NAMES avformat
             PATHS "${BMSDK_PATH}/lib/bmcv/ffmpeg/lib"
             NO_DEFAULT_PATH)
find_library(BMSDK_AVCODEC_LIBRARY
             NAMES avcodec
             PATHS "${BMSDK_PATH}/lib/bmcv/ffmpeg/lib"
             NO_DEFAULT_PATH)
find_library(BMSDK_AVFILTER_LIBRARY
             NAMES avfilter
             PATHS "${BMSDK_PATH}/lib/bmcv/ffmpeg/lib"
             NO_DEFAULT_PATH)
find_library(BMSDK_AVDEVICE_LIBRARY
             NAMES avdevice
             PATHS "${BMSDK_PATH}/lib/bmcv/ffmpeg/lib"
             NO_DEFAULT_PATH)
find_library(BMSDK_AVUTIL_LIBRARY
             NAMES avutil
             PATHS "${BMSDK_PATH}/lib/bmcv/ffmpeg/lib"
             NO_DEFAULT_PATH)
find_library(BMSDK_POSTPROC_LIBRARY
             NAMES postproc
             PATHS "${BMSDK_PATH}/lib/bmcv/ffmpeg/lib"
             NO_DEFAULT_PATH)
find_library(BMSDK_AVSWRESAMPLE_LIBRARY
             NAMES swresample
             PATHS "${BMSDK_PATH}/lib/bmcv/ffmpeg/lib"
             NO_DEFAULT_PATH)
find_library(BMSDK_AVSWSCALE_LIBRARY
             NAMES swscale
             PATHS "${BMSDK_PATH}/lib/bmcv/ffmpeg/lib"
             NO_DEFAULT_PATH)

foreach(ITEM ${BMSDK_COMPONETS})
  list(APPEND BMSDK_INCLUDE_DIRS "${BMSDK_${ITEM}_INCLUDE_DIR}")
  list(APPEND BMSDK_LIBRARIES    "${BMSDK_${ITEM}_LIBRARY}")
endforeach(ITEM)

message(STATUS "------ BMSDK_INCLUDE_DIRS = ${BMSDK_INCLUDE_DIRS}")


if(BMSDK_INCLUDE_DIRS AND BMSDK_LIBRARIES)
  set(BMSDK_FOUND TRUE)
  message(STATUS "BMSDK found")
else(BMSDK_INCLUDE_DIRS AND BMSDK_LIBRARIES)
  message(STATUS "BMSDK not found")
endif(BMSDK_INCLUDE_DIRS AND BMSDK_LIBRARIES)
