## Common Concept Python

### `sail.Tensor`

A data object manages the system/device memory of a tensor.

#### Constructor

`sail.Tensor(shape)`

**Args**:

1. shape: np.ndarray, shape of tensor.

**Returns**:

An instance of Tensor which only stores in the system memory.

`sail.Tensor(bmrt, shape)`

**Args**:

1. BmRuntime: sail.BmRuntime.
2. shape: np.ndarray, shape of tensor.

**Returns**:

An instance of Tensor which only stores in the device memory.

### `sail.BmRuntime`

A handler lives during the runtime. It can be got from a Inference instance as below:
```python
inference = sail.Inference(context_dir, chip_name, tpus, sail.IOMode.SYSO, is_dynamic, is_async)
bmrt = inference.get_bmrt()
```

### `sail.TensorMode`

an enumerator denotes which memory is used for asynchronization.

1. PING: device_mem_ping is used for input tensor while device_mem_pong is used for output tensor.
2. PONG: device_mem_pong is used for input tensor while device_mem_ping is used for output tensor.
