## NN post-process Python API

### `sail.DetectRet`

**properties**:

* x_min_ratio: the ratio of the horizontal ordinate of the top left piont of the detected box and the input image width.
* y_min_ratio: the ratio of the horizontal ordinate of the top left piont of the detected box and the input image height.
* x_max_ratio: the ratio of the horizontal ordinate of the bottom right piont of the detected box and the input image width.
* y_max_ratio: the ratio of the horizontal ordinate of the bottom right piont of the detected box and the input image height.
* class_id: the index of classificaiton result.
* score: the probability of the classificaiton result.

### `sail.ImageNetPostprocess`

Postprocessing of image classification. Get the top-k result of both class ids.

`sail.ImageNetPostprocess(batch_size, class_num, top_k)`

**Args**:

* batch_size: int, the batch size.
* class_num: int, the total number of classes.
* top_k: int, top-k number.

**Returns**:

A `sail.ImageNetPostprocess` instance.

#### `process(data)`

**Args**:

A float list of data. It's the result of the calssificatin model.

**Reutrns**:

A int list of list contains the top-k class indexes

### `sail.SsdPostprocess`

#### Constructor: 

`sail.SsdPostprocess(class_num, prior_num, threshold_conf, threhold_nms)`

**Args**:

* class_num: int, the number of calsses.
* prior_num: int, the number of prior.
* threshold_conf: float, threshold of confidence.
* threhold_nms: float, threhold of nms.

**Returns**:

A `sail.SsdPostprocess` instance.

#### `process(conf_data, loc_data, prior_data)`

**Args**:

* conf_data: A float list holds the output tensor named "mbox_conf_flatten" of the SSD model.
* loc_data: A float list holds the output tensor named "mbox_loc" of the SSD model.
* prior_data: A float list holds the output tensor named "mbox_priorbox" of the SSD model.

**Returns**:

A list of `sail.DetectRet`.

### `sail.SsdTfPostprocess`

for the postprocessing of SSD in tensorflow model zoo.

#### Constructor: 

`sail.SsdTfPostprocess(class_num, prior_num, threshold_conf, threhold_nms, max_box_num)`

**Args**:

* class_num: int, the number of calsses.
* prior_num: int, the number of prior.
* threshold_conf: float, threshold of confidence.
* threhold_nms: float, threhold of nms.
* max_box_num: int, the max value of box numbers.

**Returns**:

A `sail.SsdTfPostprocess` instance.

#### `generate_multiscale_priors(levels, img_side, scales, aspect_ratios, offset_ratio, anchor_scale)`

this function is modified from "multiscale_anchor_generator" in official tensorflow object detection.

**Args**:

* levels: vector<float>, scaling levels of feature maps for predicting.
* img_side: float, side of input image, now only support h=w.
* scales: list of float, length equals to the num of anchors at each feature point, contains sqrt which represents each anchor's area compare to base anchor.
* aspect_ratios: list of float, length equal to the num of anchors at each feature point, each value represents the value of w/h of each anchor.
* offset_ratio: float, center point offset for each anchor, between 0~1.
* anchor_scale: float, for each level of levels, "base anchor side" = "anchor_scale" * "pow(2,level)"

**Returns**:

None.

#### `process(conf_data, loc_data)`

**Args**:

* conf_data: A float list holds the output tensor named "concat_1" of the SSD model.
* loc_data: A float list holds the output tensor named "concat" of the SSD model.

**Returns**:

A list of `sail.DetectRet`
