## NN pre-process Python API

### `sail.ImageNetPreprocess()`

#### `ImageNetPreprocess()`

Compute by cpu, using the default parameters.

* height = width = 224;
* interpolation = cv::INTER_LINEAR);
* mean_0 = 103.94;
* mean_1 = 116.78;
* mean_2 = 123.68;
* scale_factor = 0.0;
* convert_color = false;

**Args**:

None.

**Returns**:

A `sail.ImageNetPreprocess` instance.

#### `ImageNetPreprocess(bm_img_processor)`

Compute by tpu, using the deault parameters as upon.

**Args**:

bm_img_processor: a BMImgProcess instance.

**Returns**:

A sail.ImageNetPreprocess instance.

#### `ImageNetPreprocess(height, width, interpolation, mean_0, mean_1, mean_2, scale_factor, convet_color)`

Compute by cpu, with specific parameters.

**Args**:

* height: int, the height of the image to resize to.
* width: int, the width of the image to resize to.
* interpolation: int, the mode of interpolation.
* mean_0: float, the mean value of the first channel to subtract.
* mean_1: float, the mean value of the second channel to subtract.
* mean_2: float, the mean value of the third channel to subtract.
* scale_factor: float, scale factor, multiply it with the image. Do nothing if scale_factor is 0.0.
* convert_color: bool, whether to convert color.

**Returns**:

A `sail.ImageNetPreprocess` instance.

#### `ImageNetPreprocess(bm_img_processor, height, width, interpolation, mean_0, mean_1, mean_2, scale_factor, convet_color)`

Compute by tpu, with specific parameters.

**Args**:

* bm_img_processor: a BMImgProcess instance.
* height: int, the height of the image to resize to.
* width: int, the width of the image to resize to.
* interpolation: int, the mode of interpolation.
* mean_0: float, the mean value of the first channel to subtract.
* mean_1: float, the mean value of the second channel to subtract.
* mean_2: float, the mean value of the third channel to subtract.
* scale_factor: float, scale factor, multiply it with the image. Do nothing if scale_factor is 0.0.
* convert_color: bool, whether to convert color.

**Returns**:

A `sail.ImageNetPreprocess` instance.

#### `process_cpu(input, offset, frame)`

Process by cpu. Before calling this function, the constructor should be 1.1 or 1.2.

**Args**:

* input: a float vector stands for the model input.
* offset: int, it stands for the offset of input address for this frame.
* frame: a cv::Mat vector contains the input frame, and the vector only has one element.

**Returns**:

None.

#### `process_tpu(input, frame)`

Process by tpu. Before calling this function, the constructor should be 1.2 or 1.4.

**Args**:

* input: a Tensor instance for the model input.
* frame: a Frame instance.

**Returns**:

None.
