/* Copyright 2016-2022 by Bitmain Technologies Inc. All rights reserved.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.

==============================================================================*/

#pragma once
#include <vector>
#include <bmruntime_interface.h>
#include <op_code.h>
#include <bmdnn_api.h>
#include "common.hpp"
#include "tensor.hpp"

namespace sail {
class Bmdnn {
 public:
  explicit Bmdnn(BmRuntime bmrt);
  ~Bmdnn() {};

  void* get_bmrt() {
    return p_bmrt_;
  }

  int sigmoid(Tensor<float>& input, Tensor<float>& output);

 private:
  void* p_bmrt_;
  bm_handle_t handle_;
};

}  // namespace sail
