"""The algorithm basefactory
"""
from __future__ import print_function
import os
from abc import ABCMeta, abstractmethod
import six

@six.add_metaclass(ABCMeta)
class BaseFactory(object):
    """abstract factory
    create algo object instance
    """
    def __init__(self, model_path=None):
        # localpath = os.path.dirname(os.path.realpath(__file__))
        localpath = os.path.expandvars('$HOME')
        if model_path is None:  # model_path: bm1682/bm1684 model path
            # model_path = os.path.join(localpath, '../../models')
            model_path = os.path.join(localpath, '.sophon/models')
            # print ("bm1682/bm1684 bmodel path: {}".format(model_path))
        self.model_path = model_path

    def set_model_path(self, model_path):
        self.model_path = model_path

    @abstractmethod
    def create(self):
        raise NotImplementedError
