"""The engine of sailalgokit

import sail lib for model deploy
"""
from ..kitconfig import ChipMode

class Engine(object):
    """Construct a inference engine
    """
    def __init__(self, arch, mode):
        if mode in [ChipMode.BM1682, ChipMode.BM1684]:
            from .bm_engine import BMEngine
            self._model = BMEngine(arch, mode)
        else:
            raise ValueError('unsupport mode: {}'.format(mode.value))
    def predict(self, input_data):
        return self._model.predict(input_data)