"""The global config info of algokit
"""
from enum import Enum

class ChipMode(Enum):
    """The deployment environment of algokit
    """
    BM1682 = 'BM1682'
    BM1684 = 'BM1684'

class ObjDetModel(Enum):
    """The object detection algorithm model
    """
    YOLOV3 = 'yolov3'
    MOBILENETSSD = 'mobilenetssd'
    MOBILENETYOLOV3 = 'mobilenetyolov3'
    FASTERRCNN = 'fasterrcnn'
    FASTERRCNN_RESNET50_TF = 'fasterrcnn_resnet50_tf'

class FaceDetModel(Enum):
    """The face detection algorithm model
    """
    MTCNN = 'mtcnn'
    SSH = 'ssh'

class ClassificationModel(Enum):
    """
    The classification algorithm model
    """
    GOOGLENET = 'googlenet'
    VGG16 = 'vgg16'
    RESNET50 = 'resnet50'
    MOBILENETV1 = 'mobilenetv1'
    MOBILENETV1_TF = 'mobilenetv1_tf'

class SegmentationModel(Enum):
    """
    The segmentation algorithm model
    """
    DEEPLABV3_MOBILENETV2_TF = 'deeplabv3_mobilenetv2_tf'
