""" test algokit deeplabv3_mobilenetv2_tf
"""
from __future__ import print_function
import cv2, os, sys
sys.path.append("../")
from algokit.algofactory.autodeploy_factory import SemanticSegment
from algokit.kitconfig import ChipMode, SegmentationModel
import time

def main():
    segment= SemanticSegment().create(SegmentationModel.DEEPLABV3_MOBILENETV2_TF, ChipMode.BM1682)
    image_path = './test_img/voc.jpg'
    image = cv2.imread(image_path)
    t0 = time.time()
    results = segment.predict(image)
    print("detect time: {}".format(time.time() - t0))
    print("segmentation result: {}".format(results))

if __name__ == '__main__':
    main()
