""" test algokit fasterrcnn_resnet50_tf
"""
from __future__ import print_function
import cv2, os, sys
sys.path.append("../")
from algokit.algofactory.autodeploy_factory import ObjectDetector
from algokit.kitconfig import ChipMode, ObjDetModel
from algokit.utils.visualization import draw_obj_bbox
import time

def main():
    detector = ObjectDetector().create(ObjDetModel.FASTERRCNN_RESNET50_TF, ChipMode.BM1682)
    image_path = './test_img/voc.jpg'
    image = cv2.imread(image_path)
    t0 = time.time()
    bboxes, classes, probs = detector.predict(image)
    print("detect time: {}".format(time.time() - t0))
    print("\x1b[32m\x1b" + "#"*31 + "Detection Results" +"#"*32+ "\x1b[0m")
    i = 0
    for bbox, cls, prob in zip(bboxes, classes, probs):
        print("{}: bbox: {} cls: {} prob: {}".format(i, bbox, cls, prob))
        i += 1
    print("\x1b[32m\x1b" + "#"*80+ "\x1b[0m")
    result = draw_obj_bbox(image, bboxes, classes, probs, "coco90")
    cv2.imshow("test", result)
    cv2.waitKey()

if __name__ == '__main__':
    main()
