""" test algokit general classifier
"""
from __future__ import print_function
import cv2, os, sys
sys.path.append("../")
from algokit.algofactory.generalclassification_factory import GeneralClassifier
from algokit.kitconfig import ChipMode, ClassificationModel
import time

def main():
    classifier = GeneralClassifier().create(ClassificationModel.MOBILENETV1_TF, ChipMode.BM1682)
    image_path1 = './test_img/cls_cat.jpg'
    image = cv2.imread(image_path1)
    t0 = time.time()
    top1, top5 = classifier.predict(image)
    print ('detect time: {}'.format(time.time() - t0))
    # return top1 / top5
    print ("top1_idx:{} top1_score:{}".format(top1['top1_idx'], top1['top1_score']))
    print ("top5_idx:{} top5_score:{}".format(top5['top5_idx'], top5['top5_score']))

if __name__ == '__main__':
    main()
