""" test algokit mobilenetyolov3
"""
from __future__ import print_function
import cv2, os, sys
sys.path.append("../")
from algokit.algofactory.objectdetection_factory import ObjectDetector
from algokit.kitconfig import ChipMode, ObjDetModel
from algokit.utils.visualization import draw_obj_bbox
import time

def main():
    detector = ObjectDetector().create(ObjDetModel.MOBILENETYOLOV3, ChipMode.BM1682)
    cap = cv2.VideoCapture("./test_video/test.mp4")
    ret, frame = cap.read()
    while ret:
        t0 = time.time()
        bboxes, classes, probs = detector.predict(frame)
        print('detect time :',time.time()-t0)
        print("\x1b[32m\x1b" + "#"*31 + "Detection Results" +"#"*32+ "\x1b[0m")
        i = 0
        for bbox, cls, prob in zip(bboxes, classes, probs):
            print(i, ": ", "bbox: ", bbox, "cls: ", cls, "prob: ", prob)
            i += 1
        print("\x1b[32m\x1b" + "#"*80+ "\x1b[0m")
        result = draw_obj_bbox(frame, bboxes, classes, probs, "coco")
        cv2.imshow("test", result)
        cv2.waitKey(10)
        ret, frame = cap.read()
    cap.release()

if __name__ == '__main__':
    main()
