""" test algokit ssh
"""
from __future__ import print_function
import cv2, os, sys
sys.path.append("../")
from algokit.algofactory.facedetection_factory import FaceDetector
from algokit.kitconfig import ChipMode, FaceDetModel
from algokit.utils.visualization import draw_face_bbox
import time

def main():
    detector = FaceDetector().create(FaceDetModel.SSH, ChipMode.BM1682)
    image_path = './test_img/face_ball.jpg'
    image = cv2.imread(image_path)
    t0 = time.time()
    bboxes, points, probs = detector.predict(image)
    print("detect time: {}".format(time.time() - t0))
    print("\x1b[32m\x1b" + "#"*30 + "Detection Results" +"#"*33+ "\x1b[0m")
    i = 0
    for bbox, point, prob in zip(bboxes, points, probs):
        print("{}: bbox: {} prob: {}".format(i, bbox, prob))
        print("point: {}".format(point))
        i += 1
    print("\x1b[32m\x1b" + "#"*80+ "\x1b[0m")
    result = draw_face_bbox(image, bboxes, probs, points)
    cv2.imshow("test", result)
    cv2.waitKey()
    # cv2.imwrite('./test_img/face_result.jpg', result)

if __name__ == '__main__':
    main()
