""" test algokit yolov3
"""
from __future__ import print_function
import cv2, os, sys
sys.path.append("../")
from algokit.algofactory.objectdetection_factory import ObjectDetector
from algokit.kitconfig import ChipMode, ObjDetModel
from algokit.utils.visualization import draw_obj_bbox
import time

def main():
    detector = ObjectDetector().create(ObjDetModel.YOLOV3, ChipMode.BM1682)
    image_path = './test_img/obj_dcc.png'
    image = cv2.imread(image_path)
    t0 = time.time()
    bboxes, classes, probs = detector.predict(image)
    print("detect time: {}".format(time.time() - t0))
    print("\x1b[32m\x1b" + "#"*30 + "Detection Results" +"#"*33+ "\x1b[0m")
    i = 0
    for bbox, cls, prob in zip(bboxes, classes, probs):
        print("{}: bbox: {} cls: {} prob: {}".format(i, bbox, cls, prob))
        i += 1
    print("\x1b[32m\x1b" + "#"*80+ "\x1b[0m")
    result = draw_obj_bbox(image, bboxes, classes, probs, "coco")
    cv2.imshow("test", result)
    cv2.waitKey()
    # cv2.imwrite('./test_img/dcc_result.jpg', result)

if __name__ == '__main__':
    main()
