from auto_deploy.common.base_compiler import Compiler
import os
import subprocess
import sys
if sys.version > '3':
  py_string = 'python3'
else:
  py_string = 'python'

class TensorflowCompiler(Compiler):
  def check_init(self):
    assert(self.platform == 'tensorflow')
    assert(self.layout == 'NHWC')

  def generate_compiling_script(self, compile_info):
    model = os.path.join(self.folder, compile_info['model_info']['model_path'])
    outdir = os.path.join(self.folder, compile_info['context_dir'])
    input_names = compile_info['input_names']
    shapes = compile_info['input_shapes']
    output_names = compile_info['output_names']
    ret = "import bmnett as bm\n"
    ret = ret + "import os\n\n"
    ret = ret + "model='{0}'\n".format(model)
    ret = ret + "outdir='{0}'\n".format(outdir)
    ret = ret + "target='{0}'\n".format(self.target)
    ret = ret + "input_names=[\n"
    for i in input_names:
      ret = ret + "'{0}',\n".format(i)
    ret = ret + "]\n"
    ret = ret + "output_names=[\n"
    for o in output_names:
      ret = ret + "'{0}',\n".format(o)
    ret = ret + "]\n"
    ret = ret + "shapes=[\n"
    for s in shapes:
      ret = ret + str(s) + ",\n"
    ret = ret + "]\n"
    ret = ret + "net_name='auto_splitted_tensorflow_graph'\n\n"
    ret = ret + "bm.compile(model, outdir, target, input_names, " + \
        "output_names, shapes, net_name, dyn={0})\n\n".format(self.dynamic)
    ret = ret + "# os.remove('bm_multi_engine_stas_0.dat')\n\n"
    with open(os.path.join(self.folder, \
        'compile_to_{0}.py'.format(compile_info['context_dir'])), 'w+') as ss:
      ss.write(ret)

  def compile_model_using_bmcompiler(self, compile_info):
    ret = subprocess.call([py_string , \
                    'compile_to_{0}.py'.format(compile_info['context_dir'])], \
                    cwd=self.folder, close_fds=True)
    if ret != 0:
      raise RuntimeError("compile failed: {}".format\
            ('compile_to_{0}.py'.format(compile_info['context_dir'])))
