* Summary
```shell
Samples List:
OpenCV + BMRT:
      - run_inceptionv1
VPU decoder:
      - vpu_decode
VPU decoder + BMCV + BMRT:
      - ffmpeg_squeezenet
```

Make sure the project root dir is the work dir.
```shell
cd sophon-inference
```

* Image classification for googlenet of Caffe model.
```shell
# compile model
# download model
python3 ./tools/downloader.py googlenet
# complie to IR
python3 ./tools/convertbmodel.py googlenet
./build/bin/run_inceptionv1 $HOME/.sophon/models/googlenet_ir ./tests/data/cls_imgs/cls_1.jpg
```

* Using vpu to decode an video.
```shell
./build/bin/vpu_decode -v ./tests/data/fenix5plus.mp4 -t 1 -i 0
```

* Using squeezenet to detect face in an video, and compare it with an face which in an image.
* This video is decoded by vpu.
```shell
# download model
python3 ./tools/downloader.py ffmpeg_squeezenet
# complie to IR
python3 ./tools/convertbmodel.py ffmpeg_squeezenet
# run the model
./build/bin/test_ffmpeg_squeezenet \
    -d $HOME/.sophon/models/ffmpeg_squeezenet_ir -h 0.8 \
    -v ./tests/data/fenix5plus.mp4 \
       ./tests/data/fenix5plus.mp4 \
       ./tests/data/fenix5plus.mp4 \
       ./tests/data/fenix5plus.mp4 \
    -p ./tests/data/ref_new.jpg -t 4 -i 0
```
