#ifndef FACE_EXTRACT_HPP_
#define FACE_EXTRACT_HPP_
#include "face_common.hpp"

class FaceExtract {
 public:
#if USE_CAFFE
  explicit FaceExtract(const std::string& proto_file,
                       const std::string& model_file);
#else
  explicit FaceExtract(bmcnn_ctx_t bmcnn_ctx);
#endif
  void extract(const cv::Mat& image, std::vector<float>& feature);

 private:
  boost::shared_ptr<__NET> net_;
  cv::Size input_geometry_;
};

#endif  // FACE_EXTRACT_HPP_
