#ifndef FACE_LANDMARK_HPP_
#define FACE_LANDMARK_HPP_
#include "face_common.hpp"

class FaceLandmark {
 public:
    #if USE_CAFFE
          explicit FaceLandmark(const std::string &proto_file,
                       const std::string &model_file);
    #else
          explicit FaceLandmark(bmcnn_ctx_t bmcnn_ctx);
    #endif
    void landmark(const cv::Mat &image, FacePts &facePt);
    void landmark(bmcv_image input_bgr, FacePts &facePt);

 private:
    boost::shared_ptr<__NET> net_;
    cv::Size input_geometry_;
};

#endif  // FACE_LANDMARK_HPP_
