/* Copyright 2016-2022 by Bitmain Technologies Inc. All rights reserved.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.  */

#include <pybind11/pybind11.h>
#include "core/common.hpp"
#include "core/tensor.hpp"
#include "core/inference.hpp"

namespace py = pybind11;

namespace sail {

// For Python, for now, we'll just always use float as the type.
typedef float Dtype;

PYBIND11_MODULE(bind, m) {
  m.attr("__version__") = "2.0.0";

  /* init_ar(); */
  /* // initialize converters */
  /* to_python_converter<cv::Mat, matToNDArrayBoostConverter>(); */
  /* matFromNDArrayBoostConverter(); */

  /* enum_<TensorMode>("TensorMode") */
  /*   .value("PING", PING) */
  /*   .value("PONG", PONG) */
  /*   .export_values(); */

  /* enum_<IOMode>("IOMode") */
  /*   .value("SYSI", SYSI) */
  /*   .value("SYSO", SYSO) */
  /*   .value("SYSIO", SYSIO) */
  /*   .value("DEVIO", DEVIO) */
  /*   .export_values(); */

  /* enum_<AsyncStatus>("AsyncStatus") */
  /*   .value("BEGIN", BEGIN) */
  /*   .value("PROCESS", PROCESS) */
  /*   .value("END", END) */
  /*   .export_values(); */

  /* class_<Tensor<Dtype>>("Tensor", init<bpn::ndarray&>()) */
  /*   .def(init<BmRuntime, bpn::ndarray&>()) */
  /*   .def("shape", &Tensor<Dtype>::shape_py) */
  /*   .def("sys_data", &Tensor<Dtype>::sys_data_py); */

  /* bpn::ndarray (Inference<Dtype>::*f0)(const std::string&, const std::string&) */
  /*     = &Inference<Dtype>::get_input_tensor_sys_py; */
  /* Tensor<Dtype> (Inference<Dtype>::*f1)(const std::string&, const std::string&) */
  /*     = &Inference<Dtype>::get_input_tensor_dev_py; */
  /* Tensor<Dtype> (Inference<Dtype>::*f2)(const std::string&, const std::string&, */
  /*     TensorMode) = &Inference<Dtype>::get_input_tensor_dev_py; */
  /* bpn::ndarray (Inference<Dtype>::*f3)(const std::string&, const std::string&) */
  /*     = &Inference<Dtype>::get_output_tensor_sys_py; */
  /* Tensor<Dtype> (Inference<Dtype>::*f4)(const std::string&, const std::string&) */
  /*     = &Inference<Dtype>::get_output_tensor_dev_py; */
  /* Tensor<Dtype> (Inference<Dtype>::*f5)(const std::string&, const std::string&, */
  /*     TensorMode) = &Inference<Dtype>::get_output_tensor_dev_py; */
  /* void (Inference<Dtype>::*f6)(const std::string& graph_name, TensorMode mode, */
  /*     AsyncStatus status) = &Inference<Dtype>::process; */
  /* void (Inference<Dtype>::*f7)(const std::string& graph_name) */
  /*     = &Inference<Dtype>::process; */

  /* class_<Inference<Dtype>>("Inference", init<const std::string&, */
  /*      const std::string&, const std::string&, IOMode, bool, bool>()) */
  /*   .def("get_bmrt", &Inference<Dtype>::get_bmrt_py) */
  /*   .def("get_all_graph_names", &Inference<Dtype>::get_all_graph_names_py) */
  /*   .def("get_input_tensor_names", &Inference<Dtype>::get_input_tensor_names_py) */
  /*   .def("get_output_tensor_names", */
  /*       &Inference<Dtype>::get_output_tensor_names_py) */
  /*   .def("get_max_input_shapes", &Inference<Dtype>::get_max_input_shapes_py) */
  /*   .def("get_input_shape", &Inference<Dtype>::get_input_shape_py) */
  /*   .def("get_output_shape", &Inference<Dtype>::get_output_shape_py) */
  /*   .def("set_input_shape_sync", &Inference<Dtype>::set_input_shape_sync_py) */
  /*   .def("set_input_shape_async", &Inference<Dtype>::set_input_shape_async_py) */
  /*   .def("set_input_tensor_sys", &Inference<Dtype>::set_input_tensor_sys_py) */
  /*   .def("get_input_tensor_sys", f0) */
  /*   .def("get_input_tensor_dev", f1) */
  /*   .def("get_input_tensor_dev", f2) */
  /*   .def("get_output_tensor_sys", f3) */
  /*   .def("get_output_tensor_dev", f4) */
  /*   .def("get_output_tensor_dev", f5) */
  /*   .def("process", f6) */
  /*   .def("process", f7) */
  /*   .def("process_sync", &Inference<Dtype>::process_sync) */
  /*   .def("process_async", &Inference<Dtype>::process_async); */
}

}  // namespace sail
