#!/bin/bash
BASE_PATH=${HOME}/.sophon/models
echo "generate ffmpeg_squeezenet bmodel..."
mkdir ${BASE_PATH}/ffmpeg_squeezenet_ir
bmnetc --model ${BASE_PATH}/ffmpeg_squeezenet/ssh_deploy.prototxt --weight ${BASE_PATH}/ffmpeg_squeezenet/SSH.caffemodel \
    --outdir ${BASE_PATH}/ffmpeg_squeezenet_ir/ssh_ir
bmnetc --model ${BASE_PATH}/ffmpeg_squeezenet/squeezenet_ssh_deploy.prototxt --weight ${BASE_PATH}/ffmpeg_squeezenet/squeezenet_21k.caffemodel \
    --outdir ${BASE_PATH}/ffmpeg_squeezenet_ir/squeezenet_ssh_ir
bmnetc --model ${BASE_PATH}/ffmpeg_squeezenet/lnet_v1_deploy.prototxt --weight ${BASE_PATH}/ffmpeg_squeezenet/lnet_v1_100k.caffemodel \
    --outdir ${BASE_PATH}/ffmpeg_squeezenet_ir/lnet_ir
bmnetc --model ${BASE_PATH}/ffmpeg_squeezenet/r50i.prototxt --weight ${BASE_PATH}/ffmpeg_squeezenet/r50i.caffemodel \
    --outdir ${BASE_PATH}/ffmpeg_squeezenet_ir/r50i_ir
echo "combine compilation.bmodel to ffmpeg_squeezenet_ir"
bm_model.bin --combine ${BASE_PATH}/ffmpeg_squeezenet_ir/ssh_ir/compilation.bmodel \
                       ${BASE_PATH}/ffmpeg_squeezenet_ir/squeezenet_ssh_ir/compilation.bmodel \
                       ${BASE_PATH}/ffmpeg_squeezenet_ir/lnet_ir/compilation.bmodel \
                       ${BASE_PATH}/ffmpeg_squeezenet_ir/r50i_ir/compilation.bmodel \
                       -o ${BASE_PATH}/ffmpeg_squeezenet_ir/compilation.bmodel
echo "remove subbmodel"
rm -rf ${BASE_PATH}/ffmpeg_squeezenet_ir/ssh_ir ${BASE_PATH}/ffmpeg_squeezenet_ir/squeezenet_ssh_ir \
       ${BASE_PATH}/ffmpeg_squeezenet_ir/lnet_ir ${BASE_PATH}/ffmpeg_squeezenet_ir/r50i_ir
rm -f ./bm_multi_engine_stas_0.dat
echo "generate bmodel ${BASE_PATH}/ffmpeg_squeezenet_ir"
