# mobilenetv1 tf compile
from __future__ import print_function
import bmnett as compiler
import argparse, os
import tensorflow as tf

def get_node_info(model):
    """
    get tensorflow model io tensor name
    """
    graph = tf.get_default_graph()
    graph_def = graph.as_graph_def()
    graph_def.ParseFromString(tf.gfile.GFile(model, 'rb').read())
    tf.import_graph_def(graph_def, name = 'pb_graph')
    tensor_name = [tensor.name for tensor in graph_def.node]
    print ("mobilenetv1 tensor_name\n", tensor_name)


def model_compile():
    """
    compile tensorflow model
    """
    base_path = os.path.join(os.path.expandvars('$HOME'), ".sophon/models")
    tfmodel_path = os.path.join(base_path, 'mobilenetv1_tf/mobilenetv1.pb')
    bmodel_path = os.path.join(base_path, 'mobilenetv1_tf_ir')
    print ('tfmodel pb file path: {}'.format(tfmodel_path))
    print ('bmodel file path: {}'.format(bmodel_path))
    # get_node_info(tfmodel_path)
    model = tfmodel_path
    outdir = bmodel_path
    target = "BM1682"
    shapes = [[1,224,224,3],]
    net_name = "mobilenetv1"
    input_names = ['input:0']
    output_names = ['MobilenetV1/Predictions/Reshape_1:0']
    compiler.compile(
            model = tfmodel_path,
            outdir = bmodel_path,
            target = target,
            shapes = shapes,
            net_name = net_name,
            input_names = input_names,
            output_names = output_names)
    os.system('rm -f bm_multi_engine_stas_0.dat')


if __name__ == "__main__":
    model_compile()

