#!/bin/bash
BASE_PATH=${HOME}/.sophon/models
echo "generate mtcnncxx bmodel..."
mkdir ${BASE_PATH}/mtcnncxx_ir
bmnetc --model ${BASE_PATH}/mtcnn/12net.prototxt --weight ${BASE_PATH}/mtcnn/12net.caffemodel \
    --shapes [1,3,576,324] --dyn true --outdir ${BASE_PATH}/mtcnncxx_ir/det1_ir
bmnetc --model ${BASE_PATH}/mtcnn/24net.prototxt --weight ${BASE_PATH}/mtcnn/24net.caffemodel \
    --shapes [32,3,24,24] --dyn true --outdir ${BASE_PATH}/mtcnncxx_ir/det2_ir
bmnetc --model ${BASE_PATH}/mtcnn/48net.prototxt --weight ${BASE_PATH}/mtcnn/48net.caffemodel \
    --shapes [32,3,48,48] --dyn true --outdir ${BASE_PATH}/mtcnncxx_ir/det3_ir
echo "combine compilation.bmodel to mtcnncxx_ir"
bm_model.bin --combine ${BASE_PATH}/mtcnncxx_ir/det1_ir/compilation.bmodel \
                       ${BASE_PATH}/mtcnncxx_ir/det2_ir/compilation.bmodel \
                       ${BASE_PATH}/mtcnncxx_ir/det3_ir/compilation.bmodel \
                       -o ${BASE_PATH}/mtcnncxx_ir/compilation.bmodel
echo "remove subbmodel"
rm -rf ${BASE_PATH}/mtcnncxx_ir/det1_ir ${BASE_PATH}/mtcnncxx_ir/det2_ir ${BASE_PATH}/mtcnncxx_ir/det3_ir
rm -f ./bm_multi_engine_stas_0.dat
echo "generate bmodel ${BASE_PATH}/mtcnncxx_ir"
