#TODO
"""sophon sample models converter
Usage: python convertbmodel.py googlenet
"""
from __future__ import print_function
import sys, os
import six.moves.urllib as urllib
import tarfile, zipfile
import argparse

global_path = os.path.dirname(os.path.realpath(__file__))

bmodel_convert_dict = {
    'googlenet': "bash " + os.path.join(global_path, "bmodelconvert_scripts/gen_googlenet_bmodel.sh"),
    'resnet50': "bash " + os.path.join(global_path, "bmodelconvert_scripts/gen_resnet50_bmodel.sh"),
    'vgg16': "bash " + os.path.join(global_path, "bmodelconvert_scripts/gen_vgg16_bmodel.sh"),
    'mobilenetv1': "bash " + os.path.join(global_path, "bmodelconvert_scripts/gen_mobilenetv1_bmodel.sh"),
    'mobilenetv1_tf': "python3 " +  os.path.join(global_path, "bmodelconvert_scripts/gen_mobilenetv1_tf_bmodel.py"),
    'fasterrcnn_vgg': "bash " + os.path.join(global_path, "bmodelconvert_scripts/gen_fasterrcnnvgg_bmodel.sh"),
    'mtcnn': "bash " + os.path.join(global_path, "bmodelconvert_scripts/gen_mtcnn_bmodel.sh"),
    'mtcnncxx': "bash " + os.path.join(global_path, "bmodelconvert_scripts/gen_mtcnncxx_bmodel.sh"),
    'ssh': "bash " + os.path.join(global_path, "bmodelconvert_scripts/gen_ssh_bmodel.sh"),
    'mobilenetssd': "bash " + os.path.join(global_path, "bmodelconvert_scripts/gen_mobilenetssd_bmodel.sh"),
    'yolov3': "bash " + os.path.join(global_path, "bmodelconvert_scripts/gen_yolov3_bmodel.sh"),
    'mobilenetyolov3': "bash " + os.path.join(global_path, "bmodelconvert_scripts/gen_mobilenetyolov3_bmodel.sh"),
    'ffmpeg_squeezenet': "bash " + os.path.join(global_path, "bmodelconvert_scripts/gen_ffmpeg_squeezenet_bmodel.sh")
}

def converttobmodel(args, model_path, save_base_path):
    if args.model_name in bmodel_convert_dict.keys():
        convert_script = bmodel_convert_dict[args.model_name]
    else:
        raise ValueError('not a available model_name {}'.format(args.model_name))
    os.system(convert_script)
    

if __name__ == '__main__':
    parser = argparse.ArgumentParser(description='convert sophon sample model to bmodel')
    parser.add_argument("model_name", help="convert model_name")
    args = parser.parse_args()
    save_base_path = os.path.join(os.path.expandvars('$HOME'), '.sophon/models')
    if args.model_name == "mtcnncxx":
        model_name = "mtcnn"
    else:
        model_name = args.model_name
    model_path = os.path.join(save_base_path, model_name)
    if not os.path.exists(model_path):
        raise ValueError("{} does not exists!. Please download it first!".format(model_path))
    converttobmodel(args, model_path, save_base_path)
