#install cmake and gnu tools python3 numpy,Just required for Python API
#
sudo apt install -y build-essential cmake
sudo apt install -y python3-dev python3-numpy python3-pip #python3-opencv 
sudo pip3 install numpy --user
sudo pip3 install gluoncv --user
sudo pip3 install opencv-contrib-python
sudo pip3 install yaml-rulz

workspace=$(cd "$(dirname "$0")";pwd)
cd ${workspace}

#install gooletest.Just required for C++ API tests
if [ -e "/usr/local/lib/libgtest.a" -a -e "/usr/local/lib/libgtest_main.a" -a -e "/usr/local/include/gtest/gtest.h" ]; then
    echo "google test already install..."
else
    echo "install gtest..."
    git clone https://github.com/google/googletest
    cd googletest
    mkdir build && cd build
    cmake .. && make && sudo make install
    cd ../.. && rm -rf googletest
fi

cd ${workspace}
#build opencv3 for source
opencv_version=`pkg-config opencv --modversion`
opencv_version=${opencv_version:0:5}
if [ ${opencv_version} == "3.4.0" ];then
  echo "opencv3.4 already install.."
else
  git clone https://github.com/opencv/opencv
  cd opencv
  git fetch && git checkout 3.4
  mkdir build && cd build
  cmake -D CMAKE_BUILD_TYPE=Release -D CMAKE_INSTALL_PREFIX=/usr/local ..
  make -j4 && sudo make install
  cd ../.. && rm -rf opencv
fi

# install Sphinx. Just required for Python API document.
pip install sphinx sphinx-autobuild sphinx_rtd_theme recommonmark
# install Doxygen. Just required for C++ API document.
sudo apt install -y doxygen texlive-full latex-cjk-chinese* cjk-latex graphviz

cd ${workspace}
#install boost 1.68
boost_version=`cat /usr/local/include/boost/version.hpp | grep "define BOOST_LIB_VERSION" |awk '{print $3}'`
boost_version=${boost_version:1:4}
if [ ${boost_version} == "1_68" ];then
   echo "boost1.68 already install.."
else
#   #install boost                    
#   sudo apt --purge remove libboost-dev
#   sudo apt --purge remove libboost-all-dev
#   sudo apt --purge autoremove libboost-all-dev
#   
#   # to uninstall the version which we installed from source
#   sudo rm -rf /usr/lib/libboost_*
#   sudo rm -rf /usr/include/boost                            
   wget https://dl.bintray.com/boostorg/release/1.68.0/source/boost_1_68_0.tar.gz

   tar -xzvf boost_1_68_0.tar.gz                                                 
   workspace=`pwd`
   mkdir boost_install
   cd boost_1_68_0 

   ./bootstrap.sh --prefix=${workspace}/boost_install --with-python-version=3.5
   
   ./b2 install --with-python
    
   # Add the Boost libraries path to the default Ubuntu library search path
   sudo /bin/bash -c 'echo "${workspace}/boost_install/lib" > /etc/ld.so.conf.d/boost.conf'
   
   # Update the default Ubuntu library search paths
   sudo ldconfig
   
   cat ${workspace}/boost_install/include/boost/version.hpp | grep "BOOST_LIB_VERSION"
fi

##install openssl
#openssl=`dpkg -l |grep openssl|wc -l`
#if [ $openssl = 2 ];then
#  echo "openssl already install.."
#else
#  wget https://www.openssl.org/source/openssl-1.1.1b.tar.gz
#  tar -zvxf openssl-1.1.1b.tar.gz
#  cd openssl-1.1.1b/
#  ./config --prefix=/usr/local
#  make
#  make install
#fi
